aboutsummaryrefslogtreecommitdiff
path: root/share/hydractl/provision-img-custom
diff options
context:
space:
mode:
Diffstat (limited to 'share/hydractl/provision-img-custom')
-rwxr-xr-xshare/hydractl/provision-img-custom135
1 files changed, 135 insertions, 0 deletions
diff --git a/share/hydractl/provision-img-custom b/share/hydractl/provision-img-custom
new file mode 100755
index 0000000..134793e
--- /dev/null
+++ b/share/hydractl/provision-img-custom
@@ -0,0 +1,135 @@
+#!/bin/bash
+#
+# System installer, virtual machine version.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public
+# License along with this program. If not, see
+# <http://www.gnu.org/licenses/>.
+
+# Load.
+source $APP_BASE/lib/hydra/functions || exit 1
+hydra_config_load
+
+# Make sure there is provision config.
+function hydra_provision_config {
+ hydra_user_config image /var/cache/qemu/debian/box.img "Destination image"
+ hydra_user_config size 3G "Image size"
+ hydra_user_config format qcow2 "Image format: raw or qcow2"
+ hydra_user_config hostname machine "Hostname"
+ hydra_user_config domain example.org "Domain"
+ hydra_user_config arch amd64 "System arch"
+ hydra_user_config version stretch "Distro version"
+ hydra_user_config mirror http://http.debian.net/debian/ "Debian mirror"
+}
+
+# Load configuration
+hydra_provision_config_load $1
+
+# Get config parameters
+hydra_provision_config
+
+# Check
+if [ -e "$image" ]; then
+ echo "error: $image already exists."
+ exit 1
+fi
+
+# Ensure base folder exists
+hydra_sudo_run mkdir -p `dirname $image`
+
+#
+# Custom version
+#
+#
+WORK="`mktemp -d`"
+
+# Check for requirements.
+for req in debootstrap grub-pc parted; do
+ hydra_install_package $req
+done
+
+echo "Creating image..."
+#hydra_sudo_run dd if=/dev/zero of=$image bs=$size count=1
+hydra_sudo_run qemu-img create -f raw $image $size
+device="`sudo losetup --find --show $image`"
+
+echo "Partitioning image at $device..."
+hydra_sudo_run parted -s -- $device mklabel gpt
+hydra_sudo_run parted -s -- $device unit MB mkpart non-fs 2 3
+hydra_sudo_run parted -s -- $device set 1 bios_grub on
+hydra_sudo_run parted -s -- $device unit MB mkpart ext2 3 -1
+hydra_sudo_run parted -s -- $device set 2 boot on
+hydra_sudo_run mkfs.ext4 ${device}p2
+hydra_sudo_run mount ${device}p2 $WORK/
+
+# Non-interactive installation
+APT_INSTALL="hydra_sudo_run LC_ALL=C DEBIAN_FRONTEND=noninteractive chroot $WORK/ apt-get install -y"
+
+# Initial system install.
+echo "Installing base system..."
+hydra_sudo_run LC_ALL=C DEBIAN_FRONTEND=noninteractive debootstrap --arch=$arch $version $WORK/ $mirror
+
+# Initial configuration.
+echo "Applying initial configuration..."
+hydra_sudo_run mount none -t proc $WORK/proc
+hydra_sudo_run mount none -t sysfs $WORK/sys
+hydra_sudo_run mount -o bind /dev/ $WORK/dev
+echo LANG=C | $SUDO tee $WORK/etc/default/locale > /dev/null
+
+# Hostname configuration.
+echo $hostname.$domain | $SUDO tee $WORK/etc/hostname > /dev/null
+echo "127.0.0.1 localhost" | $SUDO tee -a $WORK/etc/hosts > /dev/null
+
+# This ordering is important for facter correctly guess the domain name
+echo "127.0.0.1 $hostname.$domain $hostname" | $SUDO tee -a $WORK/etc/hosts > /dev/null
+
+# Invert hostname contents to avoid http://projects.puppetlabs.com/issues/2533
+tac $WORK/etc/hosts | $SUDO tee $WORK/etc/hosts.new > /dev/null
+hydra_sudo_run mv $WORK/etc/hosts.new $WORK/etc/hosts
+
+# Initial upgrade
+echo "Applying initial upgrades..."
+hydra_sudo_run chroot $WORK/ apt-get update
+hydra_sudo_run chroot $WORK/ apt-get upgrade -y
+
+if [ "$arch" == "i386" ]; then
+ kernel_arch="686"
+else
+ kernel_arch="$arch"
+fi
+
+$APT_INSTALL locales
+$APT_INSTALL screen cron lsb-release openssl -y
+$APT_INSTALL linux-image-$kernel_arch -y
+$APT_INSTALL grub-pc -y
+hydra_sudo_run chroot $WORK/ update-grub
+hydra_sudo_run chroot $WORK/ grub-install $device
+
+# Teardown
+hydra_sudo_run umount $WORK/proc
+hydra_sudo_run umount $WORK/sys
+hydra_sudo_run umount $WORK/dev
+hydra_sudo_run umount $WORK
+hydra_sudo_run rmdir $WORK
+hydra_sudo_run losetup -d $device
+
+# Image conversion
+if [ "$format" == "qcow2" ]; then
+ echo "Converting raw image to qcow2..."
+ hydra_sudo_run mv $image $image.raw
+ hydra_sudo_run qemu-img convert -O qcow2 ${image}.raw $image
+ hydra_sudo_run rm ${image}.raw
+fi
+
+# Fix permissions
+hydra_sudo_run chown -R `whoami`. `dirname $image`